//  Copyright 2016 root.ext@gmail.com
//
//  Licensed under the Apache License, Version 2.0 (the "License");
//  you may not use this file except in compliance with the License.
//  You may obtain a copy of the License at
//
//  http://www.apache.org/licenses/LICENSE-2.0
//
//  Unless required by applicable law or agreed to in writing, software
//  distributed under the License is distributed on an "AS IS" BASIS,
//  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//  See the License for the specific language governing permissions and
//  limitations under the License.

@TestOn("linux")

import '../lib/dna.dart';
import 'package:test/test.dart';
import 'dart:io';

void main() {
  group('base tests', () {
    int library;

    setUp(() {
      library = loadLibrary('libc.so.6');
    });

    tearDown(() {
      freeLibrary(library);
    });

    test('library', () {
      expect(library, isNonZero);
    });

    test('empty vm', () {
      var vm = createCallVM(256);
      expect(vm, isNonZero);
      freeCallVM(vm);
    });

    test('getpid', () {
      var method = findSymbol(library, 'getpid');
      expect(method, isNonZero);
      var vm = createCallVM(256);
      var processId = callFunction(vm, method, C_INT);
      freeCallVM(vm);

      expect(processId, isNonZero);
      expect(processId, equals(pid));
    });
  });
}
